/*
 * @(#)MP3Client.java 1.0 03/07/30
 *
 * You can modify the template of this file in the
 * directory ..\JCreator\Templates\Template_1\Project_Name.java
 *
 * You can also create your own project template by making a new
 * folder in the directory ..\JCreator\Template\. Use the other
 * templates as examples.
 *
 */
import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.io.*;
import javazoom.jl.player.*;
import java.lang.Character;

class MP3Client implements Runnable
{
	
	public MP3Client() 
	{
		CommunicationStream comStream;
		comStream = ConnectToServer("Rezzen", 1011);
		processMessages(comStream);
	}
	
	public CommunicationStream ConnectToServer(String server, int socketNum)
	{
		CommunicationStream ret;
		Socket mySocket = null;
		InetSocketAddress inet;
		OutputStream out = null;
		InputStream in = null;
		
		try
		{
			System.out.println("Attempting to connect...");
			mySocket = new Socket();	
			inet = new InetSocketAddress(server,socketNum);
			mySocket.connect(inet);
			System.out.println("Connection to server established");
			
			out = mySocket.getOutputStream();
			in = mySocket.getInputStream();
			
			ret = new CommunicationStream(in, out);
			return ret;
		}
		catch(Exception e)
		{
			System.out.println("Exception in ConnectToServer: "+server+": "+socketNum+": "+e);
			try{
				mySocket.close();
				out.close();
				in.close();
			}catch(Exception e2){}
		}
		return null;
	}
	
	public InputStream GetSongStream(String server, int socketNum)
	{
		Socket mySocket = null;
		InetSocketAddress inet;
		InputStream in = null;
		
		try
		{
			System.out.println("GetSongStream Attempting to connect...");
			mySocket = new Socket();	
			inet = new InetSocketAddress(server,socketNum);
			mySocket.connect(inet);
			System.out.println("GetSongStream Connection to server established");
			
			in = mySocket.getInputStream();
			return in;
		}
		catch(Exception e)
		{
			System.out.println("GetSongStream Exception in ConnectToServer: "+server+": "+socketNum+": "+e);
			try{
				mySocket.close();
				in.close();
			}catch(Exception e2){}
		}
		return null;
	}
	
	public void processMessages(CommunicationStream comStream)
	{
		String command="";
		String result="";
		BufferedReader keyInput = null;
		
		try
		{
			keyInput = new BufferedReader(new InputStreamReader(System.in));
			while( true )
			{
				System.out.println("");
				System.out.print(">");
				try{
					command = keyInput.readLine();}
				catch(Exception e){}
				
				if(null != command)
				{
					comStream.writeCommand(command);	
				}
				
				if( command.indexOf("play") != (-1) )
				{
					this.playSong();
					System.out.println("About to continue");
					continue;
				}
				
				result = comStream.readResult();
				while( result != null)
				{
					System.out.println("   "+result);
					result = comStream.readResult();
					if( result.compareTo("|") == 0 )
						break;
				}
			}	
		}
		finally
		{
			try{
				keyInput.close();
			}catch(Exception e){}
		}
	}
	
	public void playSong()
	{
		Thread playThread = new Thread(this);
		System.out.println("before thread");
		playThread.start();
		System.out.println("after thread");
	}
	
	public void run()
	{
		try
		{
			InputStream songStream = GetSongStream("Rezzen",1013);
			javazoom.jl.player.Player myPlayer = new javazoom.jl.player.Player(songStream);
			System.out.println("before play");
			myPlayer.play();
			System.out.println("after play");
		}
		catch(Exception e)
		{
			System.out.println("Exception in playSong::: "+e);
		}	
	}

	public static void main(String args[]) {
		System.out.println("Starting MP3Client...");
		MP3Client mainFrame = new MP3Client();
	}
}
