import java.io.InputStream;
import java.io.OutputStream;

public class CommunicationStream 
{
	private InputStream in;
	private OutputStream out;
	
	public CommunicationStream(InputStream in, OutputStream out)
	{
		this.in = in;
		this.out = out;
	}
	
	public void write(String str)
	{
		try
		{
			out.write( str.getBytes() );
		}
		catch( Exception e )
		{
			System.out.println("Exception in CommunicationStream.Write: "+str+": "+e);
		}
	}
	
	public void writeResult(String str)
	{
		int comSize = 0;
		try
		{
			comSize = str.length();
			out.write(comSize);
			this.write(str);
		}
		catch( Exception e )
		{
			System.out.println("Exception in CommunicationStream.WriteResult: "+str+": "+e);
		}
	}
	
	public void writeCommand(String str)
	{
		int comSize = 0;
		try
		{
			comSize = str.length();
			out.write(comSize);
			this.write(str);
		}
		catch( Exception e )
		{
			System.out.println("Exception in CommunicationStream.writeCommand: "+comSize+": "+str+": "+e);
		}	
	}
	
	public String readCommand()
	{
		int comSize = 0;
		
		try
		{
			comSize = this.read();
			return (this.read(comSize));
		}
		catch( Exception e )
		{
			System.out.println("Exception in CommunicationStream.readCommand: "+comSize+": "+e);
		}
		return null;
	}
	
	public String readResult()
	{
		int comSize = 0;
		try
		{
			comSize = this.read();
			return (this.read(comSize));
		}
		catch( Exception e )
		{
			System.out.println("Exception in CommunicationStream.readCommand: "+comSize+": "+e);
		}
		return null;
		
	}
	
	private String read(int numChars)
	{
		String retStr = "";
		char[] chars;
		
		if( numChars < 1)
			return null;
			
		chars = new char[numChars];
		for( int i=0; i<numChars; i++)
		{
			try{
				chars[i] = (char)in.read();	
			}catch(Exception e){ continue;};
		}
		retStr = retStr.copyValueOf(chars);
		return retStr;	
	}
	
	private int read()
	{
		try
		{
			return in.read();	
		}
		catch(Exception e)
		{
			System.out.println("Exception in CommunicationStream.read: "+e);	
		}
		return -1;
	}
}
