import java.io.File;
import java.util.LinkedList;
import java.util.Iterator;

public class MP3Dir
{
	File dir;
	LinkedList songs;
	LinkedList items;
	Iterator songIter;
	Iterator itemIter;
	
	
	public MP3Dir(String dirName)
	{
		this.dir = new File(dirName);
		songs = createMP3List(dir);
		items = createItemList(dir);
		songIter = songs.iterator();
		itemIter = items.iterator();	
	}
	
	
	public MP3Dir(File dir)
	{
		this.dir = dir;
		songs = createMP3List(dir);
		items = createItemList(dir);
		songIter = songs.iterator();
		itemIter = items.iterator();
	}
	
	
	private LinkedList createMP3List(File dir)
	{
		File[] contents;
		LinkedList ret = new LinkedList();
		
		if(!dir.isDirectory())
			return null;
		contents = dir.listFiles();
		for(int i=0; i<contents.length; i++)
		{
			if(contents[i].getName().endsWith(".mp3"))
				ret.addLast(new MP3File(contents[i]));
		}
		return ret;
	}
	
	
	private LinkedList createItemList(File dir)
	{
		File[] contents;
		LinkedList ret = new LinkedList();
		
		if(!dir.isDirectory())
			return null;
		contents = dir.listFiles();
		for(int i=0; i<contents.length; i++)
		{
			if(contents[i].isDirectory())
			{
				ret.addLast("["+contents[i].getName()+"]");
			}
			else if(contents[i].getName().endsWith(".mp3"))
			{
				ret.addLast(contents[i].getName());
			}
		}
		return ret;
	}
	
	
	public int count()
	{
		return songs.size();
	}
		
	
	public boolean hasMoreMP3s()
	{
		return songIter.hasNext(); 
	}
	
	
	public MP3File getNextMP3()
	{
		return (MP3File)songIter.next();
	}
	
	
	public String getNextItem()
	{
		return (String)itemIter.next();
	}
	
	
	public boolean hasMoreItems()
	{
		return itemIter.hasNext();
	}
}
