/*
 * @(#)MP3Server.java 1.0 03/07/30
 *
 * You can modify the template of this file in the
 * directory ..\JCreator\Templates\Template_1\Project_Name.java
 *
 * You can also create your own project template by making a new
 * folder in the directory ..\JCreator\Template\. Use the other
 * templates as examples.
 *
 */
import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.io.*;
import java.util.StringTokenizer;

class MP3Server 
{
	String curPath = "D:\\Music";
	SongStream mySongStream = null;
	
	public MP3Server() 
	{
		CommunicationStream comStream;
		
		comStream = StartConnection(1011);
		processMessages(comStream);
	}
	
	public CommunicationStream StartConnection(int socketNum)
	{
		Socket mySocket = null;
		ServerSocket mySS = null;
		OutputStream output = null;
		InputStream input = null;
		CommunicationStream ret;
		
		try
		{
			System.out.println("Starting server explorer socket on "+socketNum);
			mySS = new ServerSocket(socketNum);
			System.out.println("Explorer Socket Listening...");
				
			mySocket = mySS.accept();
			System.out.println("Connection established");
			
			output = mySocket.getOutputStream();
			input = mySocket.getInputStream();
			
			ret = new CommunicationStream(input, output);
			return ret;
		}
		catch(Exception e)
		{
			System.out.println("***Exception in Explorer server socket thread: "+e);
			try{
				mySocket.close();
				mySS.close();
				output.close();
				input.close();
			}catch(Exception e2){}
			return null;
		}	
	}
	
	
	public SongStream StartSongConnection(int socketNum)
	{
		Socket mySocket = null;
		ServerSocket mySS = null;
		OutputStream output = null;
		InputStream input = null;
		SongStream ret;
		
		try
		{
			System.out.println("Starting server song stream on socket "+socketNum);
			mySS = new ServerSocket(socketNum);
			System.out.println("Server song stream Listening...");
				
			mySocket = mySS.accept();
			System.out.println("Server Song Stream Connection established");
			
			output = mySocket.getOutputStream();
			input = mySocket.getInputStream();
			
			ret = new SongStream(input, output);
			return ret;
		}
		catch(Exception e)
		{
			System.out.println("***Exception in server song stream thread: "+e);
			try{
				mySocket.close();
				mySS.close();
				output.close();
				input.close();
			}catch(Exception e2){}
			return null;
		}	
	}
	
	
	public boolean processMessages(CommunicationStream comStream)
	{
		String[] command;
		
		try
		{
			while( true )
			{
				System.out.println("");
				System.out.println("Processing messages");
				command = parseCommand( comStream.readCommand() );	
				for( int i=0; i<command.length; i++)
					System.out.println("command: "+command[i]);
				executeCommand( Integer.parseInt(command[0]), command, comStream );
			}		
		}
		catch(Exception e)
		{
			System.out.println("Exception in processMessages:::"+e);
			return false;	
		}
	}
	
	public boolean executeCommand(int comType, String[] args, CommunicationStream comStream)
	{
		MP3Dir myDir;
		switch (comType)
		{
			case 0: //play
				myDir = new MP3Dir( curPath );
				String fileName = this.getIthMP3(Integer.parseInt(args[1]));
				mySongStream = this.StartSongConnection(1013);
				mySongStream.SendSong( fileName );
				break;
			case 1: //stop
				mySongStream.stop();
				break;
				
			case 2: //dir
				myDir = new MP3Dir( curPath );
				while( myDir.hasMoreItems() )
					comStream.writeResult( myDir.getNextItem() );
				comStream.writeResult( "|" );
				break;
			case 3: //cd
				if( 2 != args.length )
				{
					comStream.writeResult( "Unknown command" );
					comStream.writeResult( "|" );
					return false;
				}
				this.traverse(args[1]);
				myDir = new MP3Dir( curPath );
				int j=0;
				while( myDir.hasMoreItems() )
					comStream.writeResult( j+++" "+myDir.getNextItem() );
				comStream.writeResult( "|" );
				break;
			default:
				comStream.writeResult( "Unknown command" );
				comStream.writeResult( "|" );
				break;
		}
		return true;
	}
	
	
	public boolean traverse(String path)
	{
		String tempPath="";
		
		if(path.compareTo("..")==0)
			curPath = curPath.substring(0,curPath.lastIndexOf("\\"));
		else if(path.compareTo(".")==0)
			curPath = curPath;
		else if(path.indexOf(":")!=(-1))
			curPath = path;
		else
		{
			if(validateDir(curPath+"\\"+path))
				curPath=curPath+"\\"+path;
			else
			{
				tempPath = this.findMatch(path);
				if(null != tempPath && tempPath.compareTo("")!=0)
					curPath=curPath+"\\"+tempPath;
			}
		}
		return true;	
	}
	
	public boolean validateDir(String path)
	{
		File pathFile = new File(path);
		if(null==pathFile || !pathFile.isDirectory())
			return false;
		return true;
	}
	
	public String findMatch(String path)
	{
		File curDir = new File(curPath);
		File curContents[];
		
		if(null==curDir)
			return "";
		curContents = curDir.listFiles();
		if(null==curContents)
			return "";
		for(int i=0; i<curContents.length; i++)
			if(curContents[i].isDirectory())
				if(curContents[i].getName().toLowerCase().startsWith(path.toLowerCase()))
					return curContents[i].getName();
		return "";
	}
	
	public String[] parseCommand(String command)
	{	
		String[] retStr = null;
		String first = null;
		StringTokenizer myTokenizer;
		int numTokens=0;
		
		if(null == command)
			return retStr;
		
		command = command.trim();
		command = command.toLowerCase();
		myTokenizer = new StringTokenizer(command," ");
		numTokens = myTokenizer.countTokens();
		retStr = new String[numTokens];
		
		if(0==numTokens)
		{
			first = command;
		}
		else
		{	
			first = myTokenizer.nextToken();	
			
			for(int i=1; i<retStr.length; i++)
			{
				retStr[i] = myTokenizer.nextToken();
			}
		}
		
		if(first.compareTo("play")==0)
			retStr[0]="0";
		else if(first.compareTo("stop")==0)
			retStr[0]="1";
		else if(first.compareTo("dir")==0)
			retStr[0]="2";
		else if(first.compareTo("cd")==0)
			retStr[0]="3";
		else if(first.compareTo("path")==0)
			retStr[0]="4";
		else if(first.compareTo("preview")==0)
			retStr[0]="5";
		else if(first.compareTo("playdir")==0)
			retStr[0]="6";
		else if(first.indexOf(":")!=(-1))
		{
			retStr = new String[2];
			retStr[0]="7";
			retStr[1]=first;
		}
		else if(first.compareTo("exit")==0)
			retStr[0]="8";
		else if(first.compareTo("next")==0)
			retStr[0]="9";
		else
			retStr[0]="-1";
		return retStr;
	}
	
	public String getIthMP3(int index)
	{
		int mp3Count=0;
		File subs[];
		File curDir = new File(curPath);
		
		if(!curDir.isDirectory())
			return "";
		subs = curDir.listFiles();
		for(int i=0;i<subs.length;i++)
		{
			if(subs[i].isFile() && subs[i].getName().endsWith(".mp3"))
			{
				if(mp3Count==index)
					return subs[i].getAbsolutePath();
				mp3Count++;
			}
		}
		return "";
	}
	

	public static void main(String args[]) {
		System.out.println("Starting MP3Server...");
		MP3Server mainFrame = new MP3Server();
	}
}
